#!/bin/sh
#!/bin/bash
# simple Bash Menu Script by jackluke


printf '\e[96m;%s\a' "$color"

printf "$'\e[40m'APFS Recovery fix by jackluke"

printf "\n\n\n"

clear && printf '\e[3J'
echo "Welcome to the Catalina beta APFS Recovery safe and harmless fix"
echo "\nCatalina beta APFS Recovery fix can't be executed as standard user if you want to suspend the script just press CTRL+Z"
echo "\nto apply this fix your current account password is required\notherwise the script can't process\n"
echo "\nSetting nvram parameter to enforce compatibility check"
sudo nvram boot-args="-no_compat_check"
echo "Done"
sudo mount -uw /
echo "\nDownloading the Catalina Recovery package (this may take up to 10 minutes)"
curl http://swcdn.apple.com/content/downloads/42/18/061-26768-A_O5FA7ZHEQL/u0d891tovprnjtomijmqwl1mdtnb25k3ar/macOSUpd10.15.RecoveryHDUpdate.pkg --progress-bar -L -o /private/tmp/1015Recovery.pkg
echo "Done"
echo "\nExtracting the Catalina Recovery package to a temporary folder (this may take up to 5 minutes)"
pkgutil --expand /private/tmp/1015Recovery.pkg /private/tmp/recovery1015
hdiutil attach /private/tmp/recovery1015/RecoveryHDMeta.dmg
echo "Done"
echo "\nDetecting, adjusting and patching Catalina APFS Recovery"
diskutil mount Recovery
cd /Volumes/Recovery/*/
echo "\nPlease re-type password when required\n"
sudo mv PlatformSupport.plist PlatformSupportBackup.plist
sudo cp -a /Volumes/RecoveryHDMeta/ /Volumes/Recovery/*/
sudo cp -a /System/Library/PrelinkedKernels/prelinkedkernel /Volumes/Recovery/*/immutablekernel
echo "\nPlease re-type password when required\n"
sudo perl -i -pe 's/BaseSystem.dmg/BaseSystem.dmg -no_compat_check/' /Volumes/Recovery/*/com.apple.Boot.plist
hdiutil detach /Volumes/RecoveryHDMeta
rm /private/tmp/1015Recovery.pkg
rm -R /private/tmp/recovery1015
echo "Done"
echo "\nAfter decide to reboot hold CMD+R and Catalina APFS Recovery should be there\n"